﻿Public Class Form1

    Private mintScrollDirection As Integer
    Private mstrMovedItem As String

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        For intX As Integer = 1 To 100
            lstTest.Items.Add("Item # " & intX.ToString.PadLeft(3, "0"))
        Next

    End Sub

    Private Sub lstTest_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lstTest.MouseDown

        If (Control.ModifierKeys And Keys.Shift = Keys.Shift) _
        Or (Control.ModifierKeys And Keys.Control = Keys.Control) Then
            Exit Sub
        End If

        mstrMovedItem = lstTest.Text

        lstTest.DoDragDrop(lstTest.Text, DragDropEffects.All)

    End Sub

    Private Sub lstTest_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstTest.DragOver

        Dim position As Point
        position = New Point(0, 0)

        position.X = e.X
        position.Y = e.Y
        position = lstTest.PointToClient(position)

        If position.Y <= lstTest.Font.Height \ 2 Then
            ' getting close to top, ensure previous item is visible
            mintScrollDirection = 0
            tmrScroll.Enabled = True
        ElseIf position.Y >= lstTest.ClientSize.Height - lstTest.Font.Height \ 2 Then
            ' getting close to bottom, ensure next item is visible
            mintScrollDirection = 1
            tmrScroll.Enabled = True
        Else
            tmrScroll.Enabled = False
        End If

        e.Effect = DragDropEffects.Move

        position.X = e.X
        position.Y = e.Y
        position = lstTest.PointToClient(position)

    End Sub

    Private Sub lstTest_GiveFeedback(ByVal sender As Object, ByVal e As System.Windows.Forms.GiveFeedbackEventArgs) Handles lstTest.GiveFeedback

        e.UseDefaultCursors = False

        If ((e.Effect And DragDropEffects.Move) = DragDropEffects.Move) Then
            Windows.Forms.Cursor.Current = New Cursor(GetIconFromImage(picDoc.Image).Handle)
        Else
            Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default
        End If

    End Sub

    Private Sub lstTest_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstTest.DragDrop

        Dim intIndex As Integer

        intIndex = lstTest.IndexFromPoint(lstTest.PointToClient(New Point(e.X, e.Y)))
        If intIndex = -1 Then intIndex = 0
        lstTest.Items.Insert(intIndex, e.Data.GetData(DataFormats.Text))
        lstTest.Items.RemoveAt(lstTest.SelectedIndex)

        For intX As Integer = 0 To lstTest.Items.Count - 1
            If lstTest.Items(intX).ToString = mstrMovedItem Then
                lstTest.SetSelected(intX, True)
                Exit For
            End If
        Next

    End Sub

    Private Sub tmrScroll_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrScroll.Tick
        ScrollControl(lstTest, mintScrollDirection)
        tmrScroll.Enabled = False
    End Sub
End Class
