﻿Module modSupport

    Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
        (ByVal hwnd As Integer, _
            ByVal wMsg As Integer, _
            ByVal wParam As Integer, _
            ByRef lParam As Object) As Integer

    Public Function GetIconFromImage(ByVal pobjImage As Image) As Icon

        Dim bmp As Bitmap

        bmp = pobjImage

        Return (Drawing.Icon.FromHandle(bmp.GetHicon))

    End Function

    Public Sub ScrollControl(ByRef pobjControl As Control, ByRef pintDirection As Integer)

        ' This function enables a control to scroll during a drag-and-drop operation.
        ' For pintDirection, a value of 0 scrolls up; a value of 1 scrolls down.

        Const WM_SCROLL As Integer = &H115S

        SendMessage(pobjControl.Handle.ToInt32, WM_SCROLL, pintDirection, VariantType.Null)

    End Sub

End Module
